import { AfterViewInit, ComponentFactoryResolver, ComponentRef, OnChanges, SimpleChanges, TemplateRef, ViewContainerRef } from '@angular/core';
import { Loadable, LoadingState } from '../../loadable.type';
import { DefaultComponents } from '../module.options';
export declare function setComponentInputs(defaultComponentRef: ComponentRef<any>, loadable: Loadable<unknown>): void;
export declare type TemplateRefs = {
    idle?: TemplateRef<void>;
    loading?: TemplateRef<void>;
    error?: TemplateRef<{
        error: any;
    }>;
};
export declare class LoadableComponent implements OnChanges, AfterViewInit {
    private resolver;
    private defaultComponents;
    loadable: Loadable<unknown>;
    templates: TemplateRefs;
    content?: ViewContainerRef;
    defaultComponentRef?: ComponentRef<unknown>;
    templateRef?: TemplateRef<unknown>;
    showNgContent: boolean;
    templateContext?: object;
    get loadingState(): LoadingState;
    constructor(resolver: ComponentFactoryResolver, defaultComponents: DefaultComponents);
    updateContent(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
}
