export declare type LoadingState = 'idle' | 'loading' | 'loaded' | 'error';
export declare const loadingStates: LoadingState[];
export interface Idle extends ILoadable {
    type: 'idle';
}
export interface Loading extends ILoadable {
    type: 'loading';
}
export interface Loaded<T> extends ILoadable {
    type: 'loaded';
    value: T;
}
export interface Errored extends ILoadable {
    type: 'error';
    error: any;
}
export declare type Loadable<T> = Idle | Loading | Loaded<T> | Errored;
export interface ILoadable {
    type: LoadingState;
}
